<?php
class PMW_PmWiki
{
	private static $_instance = NULL;
	public static function instance()
	{
		if (!self::$_instance)
		{
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	private $_pubdirurl;
	private $_farmpubdirurl;
	private $_farmdir;

	protected function __construct()
	{
		global $PubDirUrl, $FarmPubDirUrl, $FarmD;
		$this->_pubdirurl = &$PubDirUrl;
		$this->_farmpubdirurl = &$FarmPubDirUrl;
		$this->_farmdir = &$FarmD;
	}
	
	public static function interpolate_with_pagename($string)
	{
		global $pagename;
		return FmtPageName($string,$pagename);
	}
	// accessor methods
	public function get_localdir()
	{
		return realpath('.');
	}
	public function get_localurl()
	{
		global $ScriptUrl;
		return preg_replace('#/[^/]*$#', '', $ScriptUrl, 1);
	}
	public function get_localpubdir()
	{
		return $this->get_localdir() . '/pub';
	}
	public function get_localpubdirurl()
	{
		return $this->_pubdirurl;
	}
	public function get_farmdir()
	{
		return $this->_farmdir;
	}
	public function get_farmpubdir()
	{
		return $this->get_farmdir() . '/pub';
	}
	public function get_farmpubdirurl()
	{
		return $this->_farmpubdirurl;
	}
	public function get_domainurl()
	{
		preg_match('/^(www.)?(.*)/',$_SERVER["HTTP_HOST"],$matches);
		return $matches[2];
	}
	public function get_domaindir()
	{
		return $_SERVER['DOCUMENT_ROOT'];
	}
}