<?php
class PMW_Uploads
{
	private static $_instance = NULL;
	public static function instance()
	{
		if (!self::$_instance)
		{
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	private $_uploaddir;
	private $_uploadprefixfmt;
	private $_uploadfilefmt;
	private $_uploadurlfmt;

	protected function __construct()
	{
		global $UploadDir, $UploadPrefixFmt, $UploadFileFmt, $UploadUrlFmt;
		$this->_uploaddir = &$UploadDir;
		$this->_uploadprefixfmt = &$UploadPrefixFmt;
		$this->_uploadfilefmt = &$UploadFileFmt;
		$this->_uploadurlfmt = &$UploadUrlFmt;
	}
	
	public function get_uploaddir()
	{
		return realpath($this->_uploaddir);
	}
	public function get_uploadurl()
	{
		return PMW_PmWiki::interpolate_with_pagename($this->_uploadurlfmt);
	}
}
